#!/usr/bin/env python
#-*- coding: iso-8859-15 -*-

import pygame, sys, os
from language import *
from pygame.locals import *
from scramble import *
from timer import *
from capturar import *
import timer

def load_image(folder, name):
    fullname = os.path.join(folder, name)
    image = pygame.image.load(fullname)
    image = image.convert_alpha()
    return image

class Menu(Lang):
    #MENU
    def __init__(self, size=(800, 600), name="PyRubik", icon="icon.png", \
        sizeFont = 40, color = (0, 255, 0), colorSel = (0, 255, 0),\
         pos=(300, 200, 50), center=False, theme=0 ):

        #inicializamos font y display
        pygame.font.init()
        pygame.display.init()

        self.window = pygame.display.set_mode(size)
        pygame.display.set_caption(name)
        pygame.display.set_icon(load_image("DATOS", "icon.png"))
        themes = os.listdir('themes')
        themes.sort()
        themes = themes[1:]
        font = "themes/%s" % themes[theme]
        background = "themes/%s" % themes[theme]
        self.background = load_image(background, "background.png")
        self.font = pygame.font.Font(os.path.join(font, "font.ttf") , sizeFont)
        self.fontScr = pygame.font.Font(os.path.join(font, "font.ttf") , 25)
        self.window.blit(self.background, (0,0))
        self.options = lll.menu
        self.options[5] += "<%s>" % themes[theme]
        idiomas = os.listdir('mo')[1:]

        #Creamos un reloj
        reloj = pygame.time.Clock()

        #variable o --> opcion, l--> lenguaje ej: si l = 1 --> idioma es ingles
        o = 0
        l = 1
        initLang = 0
        cont = 0
        
        while 1:
            #inicializar teclas y actualizar
            pygame.event.pump()
            keyinput = pygame.key.get_pressed()
            pygame.display.update()
            
            #Nos creamos las Surface de texto
            outMenu = []
            self.options = lll.menu
            for k in range(len(self.options)):
                if o == k:
                    outMenu.append(self.font.render(self.options[k], True, colorSel))
                else:
                    outMenu.append(self.font.render(self.options[k], True, color))
                self.window.blit(outMenu[k], (pos[0], pos[1] + k*pos[2]))
            
            
            #pintar fondo y opciones de menu
            self.window.blit(self.background, (0,0))
            for z in range(len(outMenu)):
                #opciones centradas o no
                if center == True:
                    f_rect = outMenu[z].get_rect()
                    f_rect.move_ip(pos[0], pos[1] + z*pos[2])
                    f_rect.centerx = self.window.get_rect().centerx
                else:
                    #TODO falla, mirar cuando kieras 
                    f_rect = (pos[0], pos[1] + z*pos[2])
                self.window.blit(outMenu[z], f_rect)


            #cambiar theme
            if o == 5 and (keyinput[K_RIGHT] or keyinput[K_LEFT]):
                if keyinput[K_RIGHT]:
                    theme += 1
                    if theme  > len(themes) - 1:
                        theme = 0
                elif keyinput[K_LEFT]:
                    theme -= 1
                    if theme < 0:
                        theme = len(themes) - 1 
                
                self.options = lll.menu
                self.options[5] += "<%s>" % themes[theme]
                font = "themes/%s/font.ttf" % themes[theme]
                background = "themes/%s/background.png" % themes[theme]
                mmm = Menu(color=(255,155,0,155), theme = theme)
                
            
            #cambiar idioma
            if (keyinput[K_RIGHT] or keyinput[K_LEFT]) and o == 3 or initLang == 0:
                event = pygame.event.wait()
                if event.type == KEYDOWN and keyinput[K_LEFT]:
                    l -= 1
                    if l < 0:
                        l = len(idiomas) - 1
                elif event.type == KEYDOWN and keyinput[K_RIGHT]:
                    l += 1
                    if l > len(idiomas) - 1:
                        l = 0
                lll.translate(idiomas[l])
                self.options = lll.menu
                self.options[5] += "<%s>" % themes[theme]
                for k in range(len(self.options)):
                    outMenu.insert(k, (self.font.render(self.options[k], True, color)))
                    self.window.blit(outMenu[k], (pos[0], pos[1] + k*pos[2]))
                outMenu = outMenu[:len(self.options)]
                initLang = 1

            
            #movernos en el menu
            if keyinput[K_DOWN] or keyinput[K_UP]:
                event = pygame.event.wait()
                if event.type == KEYDOWN and keyinput[K_DOWN]:
                    o += 1
                    if o >= len(self.options):
                        o = 0
                elif event.type == KEYDOWN and keyinput[K_UP]:
                    o -= 1
                    if o < 0:
                        o = len(self.options)-1  
            
            
            #entrar en la opcion seleccionada
            #TEMPORIZADOR
            if keyinput[K_RETURN] and o == 0:  
                scra = self.fontScr.render(lll.insertEsp, True, color)
                string = ""
                pygame.event.clear()
                
                #capturamos el tiempo de espera
                while 1:
                    self.window.blit(self.background, (0,0))
                    self.window.blit(scra, (0,300))
                    stringFont = self.font.render(string, True, color)
                    self.window.blit(stringFont, (100,350))
                    pygame.display.update()
                    
                    keys = pygame.event.wait()
                    if keys.type == KEYDOWN and keys.key == K_BACKSPACE:
                        string = string[:len(string)-1]
                    elif keys.type == KEYDOWN and keys.key == K_RETURN:
                        break
                    elif keys.type == KEYDOWN and keys.key == K_SPACE:
                        break
                    elif keys.type == KEYDOWN:
                        key = keys.key
                        string = string + pygame.key.name(key)
                #si no insertamos un numero la inspeccion por defecto es 15
                try:
                    string = int(string)
                except:
                    string = 15
                
                #cronometramos la espera    
                while string > 0:
                    time.sleep(1)
                    string -= 1
                    self.window.blit(self.background, (0,0))
                    stringFont = self.font.render(str(string), True, color)
                    self.window.blit(stringFont, (100,350))
                    pygame.display.update()
                    
                tim = time.time()
                tempX = 0
                pygame.event.clear()
                
                #cronometro del tiempo
                while not tempX:
                    tiempo = time.time() - tim
                    tiempoStr = str(tiempo)
                    posP =  tiempoStr.index(".")
                    cadenaTime = tiempoStr[:posP] + tiempoStr[posP:posP+3]
                    cadT = self.font.render(cadenaTime, True, color)
                    self.window.blit(self.background, (0,0))
                    self.window.blit(cadT, (500,500))
                    pygame.display.update()
                    pygame.event.pump()
                    keyinput = pygame.key.get_pressed()    
                    tempX = keyinput[K_SPACE]
                    #fps
                    reloj.tick(100)
                    pygame.time.delay(30)
                    print reloj.get_fps() #obtener los fps

                #guardar en la base de datos preguntando antes
                wantSave = self.font.render(lll.save, True, color)
                self.window.blit(wantSave, (0,300))
                pygame.display.update()
                
                while 1:
                    event = pygame.event.wait()
                    if event.type == KEYDOWN and event.key == K_n:
                        save = ""
                        break
                    elif event.type == KEYDOWN and event.key == K_y:
                        save = lll.yes[0]
                        break
                
                yes = lll.yes 
                if yes.count(save.lower()) > 0:
                    bbdd = bd.BD()
                    bbdd.guardar(tiempo, "3x3x3")
                    bbdd.close()
                    print lll.saved
            
            #SOLUCIONADOR                        
            elif keyinput[K_RETURN] and o == 1: 
                print "aun no, :("
            
            #SCRAMBLE
            elif keyinput[K_RETURN] and o == 2: 
                keyPush = pygame.key.get_pressed()
                alg = Scramble()
                scra = self.fontScr.render(alg.scramble(), True, color)
                self.window.blit(self.background, (0,0))
                self.window.blit(scra, (0,300))
                pygame.display.update()
                x = False
                while not x:
                    event = pygame.event.wait()
                    x = (event.type == KEYDOWN and event.key == K_ESCAPE)
                

            #STATISTIC
            elif keyinput[K_RETURN] and o == 4: 
                pass
            
            #CREDITOS
            elif keyinput[K_RETURN] and o == 6: 
                xx = lll.credits
                self.window.blit(self.background, (0,0))
                ss = self.font.render(xx, True, color)
                self.window.blit(ss, (60, 250))
                pygame.display.update()
                x = False
                while not x:
                    event = pygame.event.wait()
                    x = (event.type == KEYDOWN and event.key == K_ESCAPE)
                
            #SALIR
            elif keyinput[K_RETURN] and o == 7: 
                sys.exit()
   
            
            #fullscreen
            if keyinput[K_f]:
                pygame.display.toggle_fullscreen()
            if pygame.event.peek(QUIT): sys.exit()
            #fps
            #reloj.tick(100), "d"
            #pygame.time.delay(100)
            #print reloj.get_fps() #obtener los fps
            cont += 1
            print cont
            

                
mmm = Menu(color=(255,155,0,155))

